Index: code/branches/questsystem5/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/questsystem5/src/orxonox/CMakeLists.txt	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/CMakeLists.txt	(revision 2908)
@@ -20,5 +20,5 @@
 SET_SOURCE_FILES(ORXONOX_SRC_FILES
   CameraManager.cc
-  GraphicsManager.cc
+  GraphicsEngine.cc
   LevelManager.cc
   Main.cc
Index: code/branches/questsystem5/src/orxonox/CameraManager.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/CameraManager.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/CameraManager.cc	(revision 2908)
@@ -35,5 +35,5 @@
 #include <OgreResource.h>
 
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "core/Iterator.h"
 #include "objects/worldentities/Camera.h"
@@ -41,5 +41,4 @@
 #include "tools/Shader.h"
 #include "util/String.h"
-#include "gui/GUIManager.h"
 
 namespace orxonox
@@ -75,5 +74,5 @@
     void CameraManager::requestFocus(Camera* camera)
     {
-        if (!GameMode::showsGraphics())
+        if (!Core::showsGraphics())
             return;
 
@@ -100,5 +99,5 @@
     void CameraManager::releaseFocus(Camera* camera)
     {
-        if (!GameMode::showsGraphics())
+        if (!Core::showsGraphics())
             return;
 
@@ -142,5 +141,4 @@
 
         this->viewport_->setCamera(camera);
-        GUIManager::getInstance().setCamera(camera);
 
         // reactivate all visible compositors
Index: code/branches/questsystem5/src/orxonox/GraphicsEngine.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/GraphicsEngine.cc	(revision 2908)
+++ code/branches/questsystem5/src/orxonox/GraphicsEngine.cc	(revision 2908)
@@ -0,0 +1,106 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *      Benjamin Knecht <beni_at_orxonox.net>, (C) 2007
+ *   Co-authors:
+ *      Felix Schulthess
+ *
+ */
+
+/**
+@file
+@brief
+    Implementation of an partial interface to Ogre.
+*/
+
+#include "OrxonoxStableHeaders.h"
+#include "GraphicsEngine.h"
+
+#include <OgreRenderWindow.h>
+
+#include "core/CoreIncludes.h"
+#include "core/ConfigValueIncludes.h"
+#include "util/Debug.h"
+
+#include "tools/ParticleInterface.h"
+
+namespace orxonox
+{
+    //SetConsoleCommand(GraphicsEngine, printScreen, true).setKeybindMode(KeybindMode::OnPress);
+
+    GraphicsEngine* GraphicsEngine::singletonRef_s = 0;
+
+    /**
+    @brief
+        Returns the singleton instance.
+    @return
+        The only instance of GraphicsEngine.
+    */
+    /*static*/ GraphicsEngine& GraphicsEngine::getInstance()
+    {
+        assert(singletonRef_s);
+        return *singletonRef_s;
+    }
+
+    /**
+    @brief
+        Non-initialising constructor.
+    */
+    GraphicsEngine::GraphicsEngine()
+//        : root_(0)
+//        , renderWindow_(0)
+//        , viewport_(0)
+    {
+        RegisterObject(GraphicsEngine);
+
+        assert(singletonRef_s == 0);
+        singletonRef_s = this;
+
+        this->viewport_ = 0;
+
+        this->detailLevelParticle_ = 0;
+
+        this->setConfigValues();
+        CCOUT(4) << "Constructed" << std::endl;
+    }
+
+    void GraphicsEngine::setConfigValues()
+    {
+        SetConfigValue(detailLevelParticle_, 2).description("O: off, 1: low, 2: normal, 3: high").callback(this, &GraphicsEngine::detailLevelParticleChanged);
+    }
+
+    void GraphicsEngine::detailLevelParticleChanged()
+    {
+        for (ObjectList<ParticleInterface>::iterator it = ObjectList<ParticleInterface>::begin(); it; ++it)
+            it->detailLevelChanged(this->detailLevelParticle_);
+    }
+
+    /**
+    @brief
+        Destroys all the Ogre related objects
+    */
+    GraphicsEngine::~GraphicsEngine()
+    {
+        singletonRef_s = 0;
+    }
+}
Index: code/branches/questsystem5/src/orxonox/GraphicsEngine.h
===================================================================
--- code/branches/questsystem5/src/orxonox/GraphicsEngine.h	(revision 2908)
+++ code/branches/questsystem5/src/orxonox/GraphicsEngine.h	(revision 2908)
@@ -0,0 +1,96 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *      Benjamin Knecht <beni_at_orxonox.net>, (C) 2007
+ *   Co-authors:
+ *      Felix Schulthess
+ *
+ */
+
+/**
+  @file
+  @brief Declaration of GraphicsEngine Singleton.
+  @author Benjamin Knecht <beni_at_orxonox.net>
+ */
+
+#ifndef _GraphicsEngine_H__
+#define _GraphicsEngine_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <string>
+
+#include <OgrePrerequisites.h>
+#include "core/OrxonoxClass.h"
+
+namespace orxonox
+{
+    /**
+    @brief Graphics engine manager class
+    */
+    class _OrxonoxExport GraphicsEngine : public OrxonoxClass
+    {
+        // HACK: temporary means
+        friend class GSGraphics;
+
+    public:
+        GraphicsEngine();
+        ~GraphicsEngine();
+
+        void setConfigValues();
+        void detailLevelParticleChanged();
+
+        float getAverageFramesPerSecond() const   { return this->avgFramesPerSecond_; }
+        float getAverageTickTime() const          { return this->avgTickTime_; }
+        void setAverageTickTime(float tickTime)   { this->avgTickTime_ = tickTime; }
+        void setAverageFramesPerSecond(float fps) { this->avgFramesPerSecond_ = fps; }
+
+        inline unsigned int getDetailLevelParticle() const
+        { return this->detailLevelParticle_; }
+
+        static GraphicsEngine& getInstance();
+        static GraphicsEngine* getInstancePtr() { return singletonRef_s; }
+
+        inline void setViewport(Ogre::Viewport* viewport)
+            { this->viewport_ = viewport; }
+        inline Ogre::Viewport* getViewport() const
+            { return this->viewport_; }
+
+    private:
+        // don't mess with singletons
+        GraphicsEngine(GraphicsEngine&);
+
+        Ogre::Viewport*     viewport_;              //!< default full size viewport
+
+        // stats
+        float               avgTickTime_;           //!< time in ms to tick() one frame
+        float               avgFramesPerSecond_;    //!< number of frames processed in one second
+
+        // config values
+        unsigned int        detailLevelParticle_;   //!< Detail level of particle effects (0: off, 1: low, 2: normal, 3: high)
+
+        static GraphicsEngine* singletonRef_s;      //!< Pointer to the Singleton
+    };
+}
+
+#endif /* _GraphicsEngine_H__ */
Index: code/branches/questsystem5/src/orxonox/Main.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/Main.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/Main.cc	(revision 2908)
@@ -27,8 +27,4 @@
  *
  */
- 
- /**
- @mainpage Orxonox Documentation
- */
 
  /**
@@ -38,40 +34,124 @@
 
 #include "OrxonoxStableHeaders.h"
+
+#include <exception>
+#include <cassert>
+
 #include "OrxonoxConfig.h"
+#include "util/Debug.h"
+#include "util/SignalHandler.h"
+#include "core/ConfigFileManager.h"
+#include "core/CommandLine.h"
+#include "core/CommandExecutor.h"
+#include "core/Identifier.h"
+#include "core/Core.h"
+#include "core/Language.h"
 
-#include "util/Debug.h"
-#include "core/Identifier.h"
-#include "core/Game.h"
+#include "gamestates/GSRoot.h"
+#include "gamestates/GSGraphics.h"
+#include "gamestates/GSStandalone.h"
+#include "gamestates/GSServer.h"
+#include "gamestates/GSClient.h"
+#include "gamestates/GSDedicated.h"
+#include "gamestates/GSGUI.h"
+#include "gamestates/GSIOConsole.h"
 
-/*
-@brief
-    Main method. Game starts here (except for static initialisations).
-*/
+#ifdef ORXONOX_PLATFORM_APPLE
+#include <CoreFoundation/CoreFoundation.h>
+
+// This function will locate the path to our application on OS X,
+// unlike windows you can not rely on the curent working directory
+// for locating your configuration files and resources.
+             std::string macBundlePath()
+{
+    char path[1024];
+    CFBundleRef mainBundle = CFBundleGetMainBundle();
+    assert(mainBundle);
+
+    CFURLRef mainBundleURL = CFBundleCopyBundleURL(mainBundle);
+    assert(mainBundleURL);
+
+    CFStringRef cfStringRef = CFURLCopyFileSystemPath( mainBundleURL, kCFURLPOSIXPathStyle);
+    assert(cfStringRef);
+
+    CFStringGetCString(cfStringRef, path, 1024, kCFStringEncodingASCII);
+
+    CFRelease(mainBundleURL);
+    CFRelease(cfStringRef);
+
+    return std::string(path);
+}
+#endif
+
+
+SetCommandLineArgument(settingsFile, "orxonox.ini");
+SetCommandLineArgument(configFileDirectory, "");
+
 int main(int argc, char** argv)
 {
+    using namespace orxonox;
+
+    // Parse command line arguments
+    try
     {
-        orxonox::Game orxonox(argc, argv);
+        CommandLine::parseAll(argc, argv);
+    }
+    catch (ArgumentException& ex)
+    {
+        COUT(1) << ex.what() << std::endl;
+        COUT(0) << "Usage:" << std::endl << "orxonox " << CommandLine::getUsageInformation() << std::endl;
+    }
 
-        orxonox.setStateHierarchy(
-        "root"
-        " graphics"
-        "  mainMenu"
-        "  standalone"
-        "   level"
-        "  server"
-        "   level"
-        "  client"
-        "   level"
-        " dedicated"
-        "  level"
-        " ioConsole"
-        );
+    // Do this after parsing the command line to allow customisation
+    Core::postMainInitialisation();
 
-        orxonox.run();
-    } // orxonox gets destroyed right here!
+    // create a signal handler (only active for linux)
+    SignalHandler signalHandler;
+    signalHandler.doCatch(argv[0], Core::getLogPathString() + "orxonox_crash.log");
+
+    // Create the ConfigFileManager before creating the GameStates in order to have
+    // setConfigValues() in the constructor (required).
+    ConfigFileManager* configFileManager = new ConfigFileManager();
+    configFileManager->setFilename(ConfigFileType::Settings, CommandLine::getValue("settingsFile").getString());
+    // create the Core settings to configure the output level
+    Language* language = new Language();
+    Core*     core     = new Core();
+
+    // put GameStates in its own scope so we can destroy the identifiers at the end of main().
+    {
+        // create the gamestates
+        GSRoot root;
+        GSGraphics graphics;
+        GSStandalone standalone;
+        GSServer server;
+        GSClient client;
+        GSDedicated dedicated;
+        GSGUI gui;
+        GSIOConsole ioConsole;
+
+        // make the hierarchy
+        root.addChild(&graphics);
+        graphics.addChild(&standalone);
+        graphics.addChild(&server);
+        graphics.addChild(&client);
+        graphics.addChild(&gui);
+        root.addChild(&ioConsole);
+        root.addChild(&dedicated);
+
+        // Here happens the game
+        root.start();
+    }
+
+    // destroy singletons
+    delete core;
+    delete language;
+    delete configFileManager;
 
     // Clean up class hierarchy stuff (identifiers, xmlport, configvalue, consolecommand)
-    // Needs to be done after Game destructor because of ~OrxonoxClass
-    orxonox::Identifier::destroyAllIdentifiers();
+    Identifier::destroyAllIdentifiers();
+    // destroy command line arguments
+    CommandLine::destroyAllArguments();
+    // Also delete external console command that don't belong to an Identifier
+    CommandExecutor::destroyExternalCommands();
 
     return 0;
Index: code/branches/questsystem5/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- code/branches/questsystem5/src/orxonox/OrxonoxPrereqs.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/OrxonoxPrereqs.h	(revision 2908)
@@ -77,4 +77,7 @@
     namespace MunitionType
     {
+
+
+
         enum Enum
         { laserGunMunition };
@@ -94,6 +97,5 @@
 
 
-    class GraphicsManager;
-    class OgreWindowEventListener;
+    class GraphicsEngine;
     class Settings;
 
@@ -101,6 +103,4 @@
     class Radar;
     class RadarListener;
-
-    class Teamcolourable;
 
     class CameraManager;
@@ -150,12 +150,7 @@
     class ParticleSpawner;
 
-    class PongCenterpoint;
-    class PongBall;
-    class PongBat;
-
     class Camera;
     class CameraPosition;
     class SpawnPoint;
-    class TeamSpawnPoint;
 
     class Spectator;
@@ -181,5 +176,4 @@
     class LaserGun;
     class LaserGunMunition;
-    class FusionMunition;
 
     class EventListener;
@@ -192,5 +186,4 @@
     class AIController;
     class ScriptController;
-    class PongAI;
 
     class Info;
@@ -198,11 +191,7 @@
     class HumanPlayer;
     class Bot;
-    class PongBot;
     class GametypeInfo;
 
     class Gametype;
-    class Deathmatch;
-    class TeamDeathmatch;
-    class Pong;
 
     class Scores;
@@ -250,4 +239,15 @@
     //gui
     class GUIManager;
+
+    // game states
+    class GSRoot;
+    class GSGraphics;
+    class GSIO;
+    class GSIOConsole;
+    class GSLevel;
+    class GSStandalone;
+    class GSServer;
+    class GSClient;
+    class GSGUI;
 }
 
Index: code/branches/questsystem5/src/orxonox/PlayerManager.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/PlayerManager.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/PlayerManager.cc	(revision 2908)
@@ -31,5 +31,5 @@
 
 #include "LevelManager.h"
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "core/CoreIncludes.h"
 #include "objects/Level.h"
@@ -58,5 +58,5 @@
     void PlayerManager::clientConnected(unsigned int clientID)
     {
-        if (GameMode::isMaster())
+        if (Core::isMaster())
         {
             COUT(3) << "client connected" << std::endl;
@@ -77,5 +77,5 @@
     void PlayerManager::clientDisconnected(unsigned int clientID)
     {
-        if (GameMode::isMaster())
+        if (Core::isMaster())
         {
             COUT(3) << "client disconnected" << std::endl;
@@ -97,5 +97,5 @@
     PlayerInfo* PlayerManager::getClient(unsigned int clientID) const
     {
-        if (GameMode::isMaster())
+        if (Core::isMaster())
         {
             std::map<unsigned int, PlayerInfo*>::const_iterator it = this->clients_.find(clientID);
Index: code/branches/questsystem5/src/orxonox/gamestates/CMakeLists.txt
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/CMakeLists.txt	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/CMakeLists.txt	(revision 2908)
@@ -1,9 +1,9 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+  GSDedicated.cc
   GSClient.cc
-  GSDedicated.cc
   GSGraphics.cc
+  GSGUI.cc
   GSIOConsole.cc
   GSLevel.cc
-  GSMainMenu.cc
   GSRoot.cc
   GSServer.cc
Index: code/branches/questsystem5/src/orxonox/gamestates/GSClient.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSClient.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSClient.cc	(revision 2908)
@@ -31,18 +31,14 @@
 
 #include "core/input/InputManager.h"
-#include "core/Clock.h"
 #include "core/CommandLine.h"
-#include "core/Game.h"
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "network/Client.h"
 
 namespace orxonox
 {
-    AddGameState(GSClient, "client");
-
     SetCommandLineArgument(ip, "127.0.0.1").information("#.#.#.#");
 
-    GSClient::GSClient(const std::string& name)
-        : GameState(name)
+    GSClient::GSClient()
+        : GameState<GSGraphics>("client")
         , client_(0)
     {
@@ -53,7 +49,7 @@
     }
 
-    void GSClient::activate()
+    void GSClient::enter()
     {
-        GameMode::setIsClient(true);
+        Core::setIsClient(true);
 
         this->client_ = new Client(CommandLine::getValue("ip").getString(), CommandLine::getValue("port"));
@@ -62,9 +58,13 @@
             ThrowException(InitialisationFailed, "Could not establish connection with server.");
 
-        client_->update(Game::getInstance().getGameClock());
+        GSLevel::enter(this->getParent()->getViewport());
+
+        client_->tick(0);
     }
 
-    void GSClient::deactivate()
+    void GSClient::leave()
     {
+        GSLevel::leave();
+
         client_->closeConnection();
 
@@ -72,10 +72,13 @@
         delete this->client_;
 
-        GameMode::setIsClient(false);
+        Core::setIsClient(false);
     }
 
-    void GSClient::update(const Clock& time)
+    void GSClient::ticked(const Clock& time)
     {
-        client_->update(time);
+        GSLevel::ticked(time);
+        client_->tick(time.getDeltaTime());
+
+        this->tickChild(time);
     }
 }
Index: code/branches/questsystem5/src/orxonox/gamestates/GSClient.h
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSClient.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSClient.h	(revision 2908)
@@ -31,20 +31,22 @@
 
 #include "OrxonoxPrereqs.h"
-#include "core/GameState.h"
 #include "network/NetworkPrereqs.h"
+#include "GSLevel.h"
+#include "GSGraphics.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSClient : public GameState
+    class _OrxonoxExport GSClient : public GameState<GSGraphics>, public GSLevel
     {
     public:
-        GSClient(const std::string& name);
+        GSClient();
         ~GSClient();
 
-        void activate();
-        void deactivate();
-        void update(const Clock& time);
 
     private:
+        void enter();
+        void leave();
+        void ticked(const Clock& time);
+
         Client* client_;
     };
Index: code/branches/questsystem5/src/orxonox/gamestates/GSDedicated.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSDedicated.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSDedicated.cc	(revision 2908)
@@ -30,8 +30,6 @@
 #include "GSDedicated.h"
 
-#include "core/Clock.h"
 #include "core/CommandLine.h"
-#include "core/Game.h"
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "core/Iterator.h"
 #include "network/Server.h"
@@ -41,8 +39,6 @@
 namespace orxonox
 {
-    AddGameState(GSDedicated, "dedicated");
-
-    GSDedicated::GSDedicated(const std::string& name)
-        : GameState(name)
+    GSDedicated::GSDedicated()
+        : GameState<GSRoot>("dedicated")
         , server_(0)
         , timeSinceLastUpdate_(0)
@@ -54,23 +50,27 @@
     }
 
-    void GSDedicated::activate()
+    void GSDedicated::enter()
     {
-        GameMode::setHasServer(true);
+        Core::setHasServer(true);
 
         this->server_ = new Server(CommandLine::getValue("port"));
         COUT(0) << "Loading scene in server mode" << std::endl;
 
+        GSLevel::enter(0);
+
         server_->open();
     }
 
-    void GSDedicated::deactivate()
+    void GSDedicated::leave()
     {
+        GSLevel::leave();
+
         this->server_->close();
         delete this->server_;
 
-        GameMode::setHasServer(false);
+        Core::setHasServer(false);
     }
 
-    void GSDedicated::update(const Clock& time)
+    void GSDedicated::ticked(const Clock& time)
     {
 //        static float startTime = time.getSecondsPrecise();
@@ -82,5 +82,7 @@
 //            COUT(0) << "estimated ticks/sec: " << nrOfTicks/(time.getSecondsPrecise()-startTime) << endl;
             timeSinceLastUpdate_ -= static_cast<unsigned int>(timeSinceLastUpdate_ / NETWORK_PERIOD) * NETWORK_PERIOD;
-            server_->update(time);
+            GSLevel::ticked(time);
+            server_->tick(time.getDeltaTime());
+            this->tickChild(time);
         }
         else
Index: code/branches/questsystem5/src/orxonox/gamestates/GSDedicated.h
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSDedicated.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSDedicated.h	(revision 2908)
@@ -31,22 +31,23 @@
 
 #include "OrxonoxPrereqs.h"
-#include "core/GameState.h"
 #include "network/NetworkPrereqs.h"
+#include "GSLevel.h"
+#include "GSRoot.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSDedicated : public GameState
+    class _OrxonoxExport GSDedicated : public GameState<GSRoot>, public GSLevel
     {
     public:
-        GSDedicated(const std::string& name);
+        GSDedicated();
         ~GSDedicated();
 
-        void activate();
-        void deactivate();
-        void update(const Clock& time);
+    private:
+        void enter();
+        void leave();
+        void ticked(const Clock& time);
 
-    private:
-        Server* server_;
-        float   timeSinceLastUpdate_;
+        Server*      server_;
+        float        timeSinceLastUpdate_;
     };
 }
Index: code/branches/questsystem5/src/orxonox/gamestates/GSGUI.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSGUI.cc	(revision 2908)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSGUI.cc	(revision 2908)
@@ -0,0 +1,69 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "GSGUI.h"
+
+#include <OgreViewport.h>
+#include "core/input/InputManager.h"
+#include "core/input/SimpleInputState.h"
+#include "gui/GUIManager.h"
+
+namespace orxonox
+{
+    GSGUI::GSGUI()
+        : GameState<GSGraphics>("gui")
+    {
+    }
+
+    GSGUI::~GSGUI()
+    {
+    }
+
+    void GSGUI::enter()
+    {
+        guiManager_ = getParent()->getGUIManager();
+
+        // show main menu
+        guiManager_->showGUI("MainMenu", 0);
+        getParent()->getViewport()->setCamera(guiManager_->getCamera());
+    }
+
+    void GSGUI::leave()
+    {
+        guiManager_->hideGUI();
+    }
+
+    void GSGUI::ticked(const Clock& time)
+    {
+        // tick CEGUI
+        guiManager_->tick(time.getDeltaTime());
+
+        this->tickChild(time);
+    }
+}
Index: code/branches/questsystem5/src/orxonox/gamestates/GSGUI.h
===================================================================
--- code/branches/questsystem5/src/orxonox/gamestates/GSGUI.h	(revision 2908)
+++ code/branches/questsystem5/src/orxonox/gamestates/GSGUI.h	(revision 2908)
@@ -0,0 +1,53 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _GSGUI_H__
+#define _GSGUI_H__
+
+#include "OrxonoxPrereqs.h"
+#include "core/GameState.h"
+#include "GSGraphics.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport GSGUI : public GameState<GSGraphics>
+    {
+    public:
+        GSGUI();
+        ~GSGUI();
+
+    private:
+        void enter();
+        void leave();
+        void ticked(const Clock& time);
+
+        GUIManager* guiManager_;
+    };
+}
+
+#endif /* _GSGUI_H__ */
